package tests;

import static org.junit.Assert.assertTrue;

import java.util.Set;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.emf.ecore.EObject;
import org.junit.Test;

import utils.ModelBuilder;
import utils.WorkspaceUtils;
import utils.XMIUtils;
import at.qe.txture.ArchDSLStandaloneSetup;

public class ArchTest {

	@Test
	public void runTest() {
		System.out.println("TEST RUNNING");
		// if this is omitted, then - for some reason - the EMF resource.load throws an exception
		// in spite of the dependency to the DSL project...
		ArchDSLStandaloneSetup.doSetup();
		IWorkspaceRoot workspaceRoot = ResourcesPlugin.getWorkspace().getRoot();
		IProject project = workspaceRoot.getProject("ArchitectureTest");
		assertTrue(project.exists());
		System.out.println("ArchitectureTest project found.");
		Set<IFile> dslFiles = WorkspaceUtils.getAllDSLFilesInFolder(project.getLocation(), ".arch");
		System.out.println("Found " + dslFiles.size() + " DSL files.");
		Set<EObject> modelElements = WorkspaceUtils.getModelElements(dslFiles);
		System.out.println("Read " + modelElements.size() + " model root elements.");
		EObject modelRoot = ModelBuilder.build(modelElements);
		System.out.println("Built root model.");
		String XMI = XMIUtils.serializeEObjectToXMI(modelRoot);
		System.out.println("The serialized model XMI contents");
		System.out.println();
		System.out.println();
		System.out.println(XMI);
		// this should hold, but it doesn't
		assertTrue(XMI.contains("xtextLink") == false);
	}

}
