package utils;

import java.util.Set;

import org.eclipse.emf.ecore.EObject;

import at.qe.txture.archDSL.ArchDSLFactory;
import at.qe.txture.archDSL.ArchFile;
import at.qe.txture.archDSL.Fragment;

public class ModelBuilder {

	public static EObject build(final Set<EObject> elements) {
		ArchFile root = ArchDSLFactory.eINSTANCE.createArchFile();
		for (EObject element : elements) {
			if (element instanceof ArchFile) {
				root.getFragments().addAll(((ArchFile) element).getFragments());
			} else if (element instanceof Fragment) {
				root.getFragments().add((Fragment) element);
			} else {
				System.out.println("Could not determine type of eobject '" + element.toString() + "'!");
			}
		}
		return root;
	}
}
