/**
 */
package at.qe.txture.archDSL.impl;

import at.qe.txture.archDSL.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ArchDSLFactoryImpl extends EFactoryImpl implements ArchDSLFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static ArchDSLFactory init()
  {
    try
    {
      ArchDSLFactory theArchDSLFactory = (ArchDSLFactory)EPackage.Registry.INSTANCE.getEFactory(ArchDSLPackage.eNS_URI);
      if (theArchDSLFactory != null)
      {
        return theArchDSLFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new ArchDSLFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArchDSLFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case ArchDSLPackage.ARCH_FILE: return createArchFile();
      case ArchDSLPackage.FRAGMENT: return createFragment();
      case ArchDSLPackage.ORGANIZATIONAL_COMPONENT: return createOrganizationalComponent();
      case ArchDSLPackage.COMPANY: return createCompany();
      case ArchDSLPackage.DEPARTMENT: return createDepartment();
      case ArchDSLPackage.LOCATION: return createLocation();
      case ArchDSLPackage.BUILDING: return createBuilding();
      case ArchDSLPackage.ROOM: return createRoom();
      case ArchDSLPackage.HARDWARE_COMPONENT: return createHardwareComponent();
      case ArchDSLPackage.SERVER: return createServer();
      case ArchDSLPackage.SERVICE: return createService();
      case ArchDSLPackage.SOFTWARE_SERVICE: return createSoftwareService();
      case ArchDSLPackage.PROXY_SERVICE: return createProxyService();
      case ArchDSLPackage.WORKSTATION: return createWorkstation();
      case ArchDSLPackage.MOBILE_DEVICE: return createMobileDevice();
      case ArchDSLPackage.SOFTWARE_COMPONENT: return createSoftwareComponent();
      case ArchDSLPackage.APPLICATION: return createApplication();
      case ArchDSLPackage.OPERATING_SYSTEM: return createOperatingSystem();
      case ArchDSLPackage.PERSON: return createPerson();
      case ArchDSLPackage.SYSTEM_SPECS: return createSystemSpecs();
      case ArchDSLPackage.MEMORY_SPECIFICATION: return createMemorySpecification();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case ArchDSLPackage.SERVER_TYPE:
        return createServerTypeFromString(eDataType, initialValue);
      case ArchDSLPackage.MEMORY_UNIT:
        return createMemoryUnitFromString(eDataType, initialValue);
      case ArchDSLPackage.VISIBILITY:
        return createVisibilityFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case ArchDSLPackage.SERVER_TYPE:
        return convertServerTypeToString(eDataType, instanceValue);
      case ArchDSLPackage.MEMORY_UNIT:
        return convertMemoryUnitToString(eDataType, instanceValue);
      case ArchDSLPackage.VISIBILITY:
        return convertVisibilityToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArchFile createArchFile()
  {
    ArchFileImpl archFile = new ArchFileImpl();
    return archFile;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Fragment createFragment()
  {
    FragmentImpl fragment = new FragmentImpl();
    return fragment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OrganizationalComponent createOrganizationalComponent()
  {
    OrganizationalComponentImpl organizationalComponent = new OrganizationalComponentImpl();
    return organizationalComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Company createCompany()
  {
    CompanyImpl company = new CompanyImpl();
    return company;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Department createDepartment()
  {
    DepartmentImpl department = new DepartmentImpl();
    return department;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Location createLocation()
  {
    LocationImpl location = new LocationImpl();
    return location;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Building createBuilding()
  {
    BuildingImpl building = new BuildingImpl();
    return building;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Room createRoom()
  {
    RoomImpl room = new RoomImpl();
    return room;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareComponent createHardwareComponent()
  {
    HardwareComponentImpl hardwareComponent = new HardwareComponentImpl();
    return hardwareComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Server createServer()
  {
    ServerImpl server = new ServerImpl();
    return server;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Service createService()
  {
    ServiceImpl service = new ServiceImpl();
    return service;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftwareService createSoftwareService()
  {
    SoftwareServiceImpl softwareService = new SoftwareServiceImpl();
    return softwareService;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ProxyService createProxyService()
  {
    ProxyServiceImpl proxyService = new ProxyServiceImpl();
    return proxyService;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Workstation createWorkstation()
  {
    WorkstationImpl workstation = new WorkstationImpl();
    return workstation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MobileDevice createMobileDevice()
  {
    MobileDeviceImpl mobileDevice = new MobileDeviceImpl();
    return mobileDevice;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftwareComponent createSoftwareComponent()
  {
    SoftwareComponentImpl softwareComponent = new SoftwareComponentImpl();
    return softwareComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Application createApplication()
  {
    ApplicationImpl application = new ApplicationImpl();
    return application;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OperatingSystem createOperatingSystem()
  {
    OperatingSystemImpl operatingSystem = new OperatingSystemImpl();
    return operatingSystem;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Person createPerson()
  {
    PersonImpl person = new PersonImpl();
    return person;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SystemSpecs createSystemSpecs()
  {
    SystemSpecsImpl systemSpecs = new SystemSpecsImpl();
    return systemSpecs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MemorySpecification createMemorySpecification()
  {
    MemorySpecificationImpl memorySpecification = new MemorySpecificationImpl();
    return memorySpecification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ServerType createServerTypeFromString(EDataType eDataType, String initialValue)
  {
    ServerType result = ServerType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertServerTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MemoryUnit createMemoryUnitFromString(EDataType eDataType, String initialValue)
  {
    MemoryUnit result = MemoryUnit.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertMemoryUnitToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Visibility createVisibilityFromString(EDataType eDataType, String initialValue)
  {
    Visibility result = Visibility.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertVisibilityToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArchDSLPackage getArchDSLPackage()
  {
    return (ArchDSLPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static ArchDSLPackage getPackage()
  {
    return ArchDSLPackage.eINSTANCE;
  }

} //ArchDSLFactoryImpl
