/**
 */
package at.qe.txture.archDSL.util;

import at.qe.txture.archDSL.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see at.qe.txture.archDSL.ArchDSLPackage
 * @generated
 */
public class ArchDSLAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static ArchDSLPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArchDSLAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = ArchDSLPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ArchDSLSwitch<Adapter> modelSwitch =
    new ArchDSLSwitch<Adapter>()
    {
      @Override
      public Adapter caseArchFile(ArchFile object)
      {
        return createArchFileAdapter();
      }
      @Override
      public Adapter caseFragment(Fragment object)
      {
        return createFragmentAdapter();
      }
      @Override
      public Adapter caseOrganizationalComponent(OrganizationalComponent object)
      {
        return createOrganizationalComponentAdapter();
      }
      @Override
      public Adapter caseCompany(Company object)
      {
        return createCompanyAdapter();
      }
      @Override
      public Adapter caseDepartment(Department object)
      {
        return createDepartmentAdapter();
      }
      @Override
      public Adapter caseLocation(Location object)
      {
        return createLocationAdapter();
      }
      @Override
      public Adapter caseBuilding(Building object)
      {
        return createBuildingAdapter();
      }
      @Override
      public Adapter caseRoom(Room object)
      {
        return createRoomAdapter();
      }
      @Override
      public Adapter caseHardwareComponent(HardwareComponent object)
      {
        return createHardwareComponentAdapter();
      }
      @Override
      public Adapter caseServer(Server object)
      {
        return createServerAdapter();
      }
      @Override
      public Adapter caseService(Service object)
      {
        return createServiceAdapter();
      }
      @Override
      public Adapter caseSoftwareService(SoftwareService object)
      {
        return createSoftwareServiceAdapter();
      }
      @Override
      public Adapter caseProxyService(ProxyService object)
      {
        return createProxyServiceAdapter();
      }
      @Override
      public Adapter caseWorkstation(Workstation object)
      {
        return createWorkstationAdapter();
      }
      @Override
      public Adapter caseMobileDevice(MobileDevice object)
      {
        return createMobileDeviceAdapter();
      }
      @Override
      public Adapter caseSoftwareComponent(SoftwareComponent object)
      {
        return createSoftwareComponentAdapter();
      }
      @Override
      public Adapter caseApplication(Application object)
      {
        return createApplicationAdapter();
      }
      @Override
      public Adapter caseOperatingSystem(OperatingSystem object)
      {
        return createOperatingSystemAdapter();
      }
      @Override
      public Adapter casePerson(Person object)
      {
        return createPersonAdapter();
      }
      @Override
      public Adapter caseSystemSpecs(SystemSpecs object)
      {
        return createSystemSpecsAdapter();
      }
      @Override
      public Adapter caseMemorySpecification(MemorySpecification object)
      {
        return createMemorySpecificationAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.ArchFile <em>Arch File</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.ArchFile
   * @generated
   */
  public Adapter createArchFileAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Fragment <em>Fragment</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Fragment
   * @generated
   */
  public Adapter createFragmentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.OrganizationalComponent <em>Organizational Component</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.OrganizationalComponent
   * @generated
   */
  public Adapter createOrganizationalComponentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Company <em>Company</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Company
   * @generated
   */
  public Adapter createCompanyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Department <em>Department</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Department
   * @generated
   */
  public Adapter createDepartmentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Location <em>Location</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Location
   * @generated
   */
  public Adapter createLocationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Building <em>Building</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Building
   * @generated
   */
  public Adapter createBuildingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Room <em>Room</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Room
   * @generated
   */
  public Adapter createRoomAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.HardwareComponent <em>Hardware Component</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.HardwareComponent
   * @generated
   */
  public Adapter createHardwareComponentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Server <em>Server</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Server
   * @generated
   */
  public Adapter createServerAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Service <em>Service</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Service
   * @generated
   */
  public Adapter createServiceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.SoftwareService <em>Software Service</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.SoftwareService
   * @generated
   */
  public Adapter createSoftwareServiceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.ProxyService <em>Proxy Service</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.ProxyService
   * @generated
   */
  public Adapter createProxyServiceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Workstation <em>Workstation</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Workstation
   * @generated
   */
  public Adapter createWorkstationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.MobileDevice <em>Mobile Device</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.MobileDevice
   * @generated
   */
  public Adapter createMobileDeviceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.SoftwareComponent <em>Software Component</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.SoftwareComponent
   * @generated
   */
  public Adapter createSoftwareComponentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Application <em>Application</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Application
   * @generated
   */
  public Adapter createApplicationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.OperatingSystem <em>Operating System</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.OperatingSystem
   * @generated
   */
  public Adapter createOperatingSystemAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.Person <em>Person</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.Person
   * @generated
   */
  public Adapter createPersonAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.SystemSpecs <em>System Specs</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.SystemSpecs
   * @generated
   */
  public Adapter createSystemSpecsAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link at.qe.txture.archDSL.MemorySpecification <em>Memory Specification</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see at.qe.txture.archDSL.MemorySpecification
   * @generated
   */
  public Adapter createMemorySpecificationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //ArchDSLAdapterFactory
