/**
 */
package at.qe.txture.archDSL.util;

import at.qe.txture.archDSL.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see at.qe.txture.archDSL.ArchDSLPackage
 * @generated
 */
public class ArchDSLSwitch<T> extends Switch<T>
{
  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static ArchDSLPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArchDSLSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = ArchDSLPackage.eINSTANCE;
    }
  }

  /**
   * Checks whether this is a switch for the given package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @parameter ePackage the package in question.
   * @return whether this is a switch for the given package.
   * @generated
   */
  @Override
  protected boolean isSwitchFor(EPackage ePackage)
  {
    return ePackage == modelPackage;
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  @Override
  protected T doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case ArchDSLPackage.ARCH_FILE:
      {
        ArchFile archFile = (ArchFile)theEObject;
        T result = caseArchFile(archFile);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.FRAGMENT:
      {
        Fragment fragment = (Fragment)theEObject;
        T result = caseFragment(fragment);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.ORGANIZATIONAL_COMPONENT:
      {
        OrganizationalComponent organizationalComponent = (OrganizationalComponent)theEObject;
        T result = caseOrganizationalComponent(organizationalComponent);
        if (result == null) result = caseFragment(organizationalComponent);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.COMPANY:
      {
        Company company = (Company)theEObject;
        T result = caseCompany(company);
        if (result == null) result = caseOrganizationalComponent(company);
        if (result == null) result = caseFragment(company);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.DEPARTMENT:
      {
        Department department = (Department)theEObject;
        T result = caseDepartment(department);
        if (result == null) result = caseOrganizationalComponent(department);
        if (result == null) result = caseFragment(department);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.LOCATION:
      {
        Location location = (Location)theEObject;
        T result = caseLocation(location);
        if (result == null) result = caseFragment(location);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.BUILDING:
      {
        Building building = (Building)theEObject;
        T result = caseBuilding(building);
        if (result == null) result = caseLocation(building);
        if (result == null) result = caseFragment(building);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.ROOM:
      {
        Room room = (Room)theEObject;
        T result = caseRoom(room);
        if (result == null) result = caseLocation(room);
        if (result == null) result = caseFragment(room);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.HARDWARE_COMPONENT:
      {
        HardwareComponent hardwareComponent = (HardwareComponent)theEObject;
        T result = caseHardwareComponent(hardwareComponent);
        if (result == null) result = caseFragment(hardwareComponent);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.SERVER:
      {
        Server server = (Server)theEObject;
        T result = caseServer(server);
        if (result == null) result = caseHardwareComponent(server);
        if (result == null) result = caseFragment(server);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.SERVICE:
      {
        Service service = (Service)theEObject;
        T result = caseService(service);
        if (result == null) result = caseFragment(service);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.SOFTWARE_SERVICE:
      {
        SoftwareService softwareService = (SoftwareService)theEObject;
        T result = caseSoftwareService(softwareService);
        if (result == null) result = caseService(softwareService);
        if (result == null) result = caseFragment(softwareService);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.PROXY_SERVICE:
      {
        ProxyService proxyService = (ProxyService)theEObject;
        T result = caseProxyService(proxyService);
        if (result == null) result = caseService(proxyService);
        if (result == null) result = caseFragment(proxyService);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.WORKSTATION:
      {
        Workstation workstation = (Workstation)theEObject;
        T result = caseWorkstation(workstation);
        if (result == null) result = caseHardwareComponent(workstation);
        if (result == null) result = caseFragment(workstation);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.MOBILE_DEVICE:
      {
        MobileDevice mobileDevice = (MobileDevice)theEObject;
        T result = caseMobileDevice(mobileDevice);
        if (result == null) result = caseHardwareComponent(mobileDevice);
        if (result == null) result = caseFragment(mobileDevice);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.SOFTWARE_COMPONENT:
      {
        SoftwareComponent softwareComponent = (SoftwareComponent)theEObject;
        T result = caseSoftwareComponent(softwareComponent);
        if (result == null) result = caseFragment(softwareComponent);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.APPLICATION:
      {
        Application application = (Application)theEObject;
        T result = caseApplication(application);
        if (result == null) result = caseSoftwareComponent(application);
        if (result == null) result = caseFragment(application);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.OPERATING_SYSTEM:
      {
        OperatingSystem operatingSystem = (OperatingSystem)theEObject;
        T result = caseOperatingSystem(operatingSystem);
        if (result == null) result = caseSoftwareComponent(operatingSystem);
        if (result == null) result = caseFragment(operatingSystem);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.PERSON:
      {
        Person person = (Person)theEObject;
        T result = casePerson(person);
        if (result == null) result = caseFragment(person);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.SYSTEM_SPECS:
      {
        SystemSpecs systemSpecs = (SystemSpecs)theEObject;
        T result = caseSystemSpecs(systemSpecs);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ArchDSLPackage.MEMORY_SPECIFICATION:
      {
        MemorySpecification memorySpecification = (MemorySpecification)theEObject;
        T result = caseMemorySpecification(memorySpecification);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Arch File</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Arch File</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseArchFile(ArchFile object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Fragment</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Fragment</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFragment(Fragment object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Organizational Component</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Organizational Component</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseOrganizationalComponent(OrganizationalComponent object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Company</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Company</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseCompany(Company object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Department</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Department</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseDepartment(Department object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Location</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Location</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseLocation(Location object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Building</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Building</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseBuilding(Building object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Room</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Room</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseRoom(Room object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Hardware Component</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Hardware Component</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseHardwareComponent(HardwareComponent object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Server</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Server</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseServer(Server object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Service</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Service</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseService(Service object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Software Service</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Software Service</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSoftwareService(SoftwareService object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Proxy Service</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Proxy Service</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseProxyService(ProxyService object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Workstation</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Workstation</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseWorkstation(Workstation object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Mobile Device</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Mobile Device</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseMobileDevice(MobileDevice object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Software Component</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Software Component</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSoftwareComponent(SoftwareComponent object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Application</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Application</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseApplication(Application object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Operating System</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Operating System</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseOperatingSystem(OperatingSystem object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Person</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Person</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T casePerson(Person object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>System Specs</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>System Specs</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSystemSpecs(SystemSpecs object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Memory Specification</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Memory Specification</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseMemorySpecification(MemorySpecification object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  @Override
  public T defaultCase(EObject object)
  {
    return null;
  }

} //ArchDSLSwitch
