package at.qe.txture.converter

import org.eclipse.xtext.conversion.IValueConverter
import org.eclipse.xtext.conversion.ValueConverterException
import org.eclipse.xtext.nodemodel.INode

public class FloatValueConverter implements IValueConverter<Float>{
	
	override String toString(Float value) throws ValueConverterException {
		return value.toString;
	}
	
	override Float toValue(String string, INode node) throws ValueConverterException {
		if(string == null || string.trim.empty){
			throw new ValueConverterException("Can't convert empty string to Float.", node, null);
		}
		try{
			return Float::parseFloat(string);
		}catch(NumberFormatException nfe){
			throw new ValueConverterException("Illegal format: can't convert to Float.", node, nfe);
		}
	}
	
	
}