package at.qe.txture.converter

import org.eclipse.xtext.conversion.IValueConverter
import java.net.URL
import org.eclipse.xtext.conversion.ValueConverterException
import org.eclipse.xtext.nodemodel.INode
import java.net.MalformedURLException

public class URLValueConverter implements IValueConverter<URL>{
	
	override String toString(URL value) throws ValueConverterException {
		return value.toString;
	}
	
	override toValue(String string, INode node) throws ValueConverterException {
		if(string == null || string.trim.empty){
			throw new ValueConverterException("Cannot build URL from empty string!", node, null);
		}
		try{
			return new URL(string);
		}catch(MalformedURLException e){
			throw new ValueConverterException("Cannot build URL - format is invalid.", node, null);
		}
	}
	
}