package at.qe.txture.converter;

import com.google.common.base.Objects;
import org.eclipse.xtext.conversion.IValueConverter;
import org.eclipse.xtext.conversion.ValueConverterException;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.xbase.lib.Exceptions;

@SuppressWarnings("all")
public class FloatValueConverter implements IValueConverter<Float> {
  public String toString(final Float value) throws ValueConverterException {
    return value.toString();
  }
  
  public Float toValue(final String string, final INode node) throws ValueConverterException {
    boolean _or = false;
    boolean _equals = Objects.equal(string, null);
    if (_equals) {
      _or = true;
    } else {
      String _trim = string.trim();
      boolean _isEmpty = _trim.isEmpty();
      _or = (_equals || _isEmpty);
    }
    if (_or) {
      ValueConverterException _valueConverterException = new ValueConverterException("Can\'t convert empty string to Float.", node, null);
      throw _valueConverterException;
    }
    try {
      return Float.valueOf(Float.parseFloat(string));
    } catch (final Throwable _t) {
      if (_t instanceof NumberFormatException) {
        final NumberFormatException nfe = (NumberFormatException)_t;
        ValueConverterException _valueConverterException_1 = new ValueConverterException("Illegal format: can\'t convert to Float.", node, nfe);
        throw _valueConverterException_1;
      } else {
        throw Exceptions.sneakyThrow(_t);
      }
    }
  }
}
