package at.qe.txture.converter;

import com.google.common.base.Objects;
import java.net.MalformedURLException;
import java.net.URL;
import org.eclipse.xtext.conversion.IValueConverter;
import org.eclipse.xtext.conversion.ValueConverterException;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.xbase.lib.Exceptions;

@SuppressWarnings("all")
public class URLValueConverter implements IValueConverter<URL> {
  public String toString(final URL value) throws ValueConverterException {
    return value.toString();
  }
  
  public URL toValue(final String string, final INode node) throws ValueConverterException {
    boolean _or = false;
    boolean _equals = Objects.equal(string, null);
    if (_equals) {
      _or = true;
    } else {
      String _trim = string.trim();
      boolean _isEmpty = _trim.isEmpty();
      _or = (_equals || _isEmpty);
    }
    if (_or) {
      ValueConverterException _valueConverterException = new ValueConverterException("Cannot build URL from empty string!", node, null);
      throw _valueConverterException;
    }
    try {
      try {
        URL _uRL = new URL(string);
        return _uRL;
      } catch (Throwable _e) {
        throw Exceptions.sneakyThrow(_e);
      }
    } catch (final Throwable _t) {
      if (_t instanceof MalformedURLException) {
        final MalformedURLException e = (MalformedURLException)_t;
        ValueConverterException _valueConverterException_1 = new ValueConverterException("Cannot build URL - format is invalid.", node, null);
        throw _valueConverterException_1;
      } else {
        throw Exceptions.sneakyThrow(_t);
      }
    }
  }
}
